// IP-Adresskalkulator 
// Erm�glicht Netze- und Host-IP Adressen zu ermitteln. 
// Das Tool beherscht IP-Adressen der Version 4

// Copyright: Uwe Pfeffer 2005, 2008 mailto:3231-692@online.de
//            Dahlmannstrasse 36, D-60385 Frankfurt am Main, Germany
// Diese Programm ist unter Bedingungen der GNU General Public License veroeffentlicht.
// Sie finden einer Version der GNU General Public License in der Distribution zu diesem Programm oder unter:
// http://www.gnu.org/licenses/gpl.txt
// Eine deutschsprachiger (nicht rechtverbindlicher) Version der GNU General Public License finden Sie unter:
// http://www.gnu.de/documents/gpl.de.html
// This Programm is puplishied under conditions of the GNU General Public License.
// You find a Text Version of the GNU General Public License inside of distribtion for this programm or under
// http://www.gnu.org/licenses/gpl.txt



// Versions�Uebersicht
// Version 0.1 Erstellt: 23.07.05    Los gehts, noch nicht lauffaehige Version!
// Version 1.0 Erstellt: 06.08.05    Erste, lauffaeige Version.
// Version 1.1 Erstellt: 07.08.05    Analysefunktion eingefuegt, die ggf. Hinweise zum Ergebniss
//                                   ausgibt.
// Version 1.2 Erstellt: 25.08.05    Funktion zur Ausgabe des Ergebnisses in Netzdialog Notation eingefuegt.
// Version 1.3 Erstellt: 29.08.05    Neue Butons eingefuegt (Kosmetik).
//                                   Grafik nun im Stammverzeichniss des Kalkulators abgelegt.
//                                   Funktion zum hoch- und herunterzaehlenkompletter Netze eingefuegt
// Version 1.4 Erstellt: 28.10.05    Unglueckliche Variablenzuweisung in Funktionen Netdup() und Netdown()
//                                   behoben.
//                                   Funktion zum automatischen Generieren von Netz eingefuegt.
// Version 1.5 Erstellt: 24.03.08    Neues Logo eingefuehrt, einige Texte auf der Oberflaeche geaendert.
//                                   Druckknoepfe annimiert.
//	                             Variablenamen fuer Ausgabe mit fuerenden Nullen geaendert.
//				     Ermittlung der Wildcardmask eingefuegt.
//			             Plausipruefung für Laenge der Netzmaske eingefuegt.
//				     Tool unter GPL-Lizens gestellt.


// Bekannte Bugs und to do's:
// Word-structur durch Results-structur ersetzen (uebrsichtlicher) 
// Bei fehlerhafter Eingabe koennte die Ausgabefelder geloescht werden.
// In den Hinweisen und Fehlermeldungen funktionieren die Umlaute nicht.
// Konqueror kommt mit der Listenestellung nicht klar (Popup-Einstelungen??).

// Globale Variablen
var unpressed_button;			// String mit Dateiname des nicht gedrueckten Buttons.
var feld_name;				// String die den HTML-Feldname des gedrueckten Buttons.


// Objektbeschreibung fuer das Objekt Word.
// Mit diesem Objekt werden IP-Adressen und Netzmasken beschrieben.
// Es beinhaltet die Netzmaske bzw. IP-Adresse als String in der Notation a.b.c.d,
// als Array mit 4-dezimalen Werten sowie als 4-Byte (32-Bit) langer hexadezimal Wert.


function word(Str, Dez, Hex, NMlength, Notation ) {
        this.Str = Str;               // Word als String in der Notation a.b.c.d
        this.Dez = new Array(4);      // Word als Arry mit 4 dezimalen Werten MSB is [0]
        this.Hex = Hex;               // Word als Hexadezimalen Wert
        this.NMlength = NMlength;     // Laenge der Netzmaske als dezimaler Wert. (Kommt nur bei
                                      // der Verwendung im Zusmammenhang mit der Netzmaske zum
                                      // Einsatz.
        this.Notation = Notation;     // Flag, hier wird festglegt in welcher Notation die 
                                      // Ergebnisse Dargestellt werden sollen
        this.dezToHex = dezToHex;     // Methode zum Umwandeln der 4 dezimalen Zahlen in einen
                                      // zusammenhaengenden HEX-Wert mit 32-Bit laenge
        this.hexToDez2 = hexToDez2;   // Methode zum Umwandeln des 32-Bit HEX-Wertes in Array aus 
                                      // 4 dezimalen Werten 
        this.dezToString2 = dezToString2; // Methode fuer die Verwandelt die Dezimalwerte die in 
                                          // einen String
        this.NMlengthToString = NMlengthToString;
                                      // Methode fuer die Konvertiert die Laenge der Netzmaske in
                                      //den Netzmasken-String
        this.StringToNMlength = StringToNMlength;
                                      // Methode fuer die Konvertiert den Netzmasken-String in die
                                      // Laenge der Netzmaske.
        this.analyse = analyse;       // Methode die das Ergebnis analysiert und ggf. einen
                                      // Kommentar in das Feld comment schreibt.
}

// Objektbeschreibung fuer das Objekt results.
// Diese Strucktur ist fuer die Ergebnissaufnahme gedacht.
function result(HexIpAdress, HexNetMask, HexNetAdress, HexWildcard, DezNetAdress, DezNetmLength, HexInvNetmask, StrWildcardmask, StrNetAdress, HexFirstHost, HexLastHost, HexBroadcast, DezNbrHosts, comment, Notation) {
         this.HexIpAdress = HexIpAdress;         // Eingegeben IP-Adresse in Hexadezimal
         this.HexNetMask = HexNetMask;           // Eingegeben Netzmaske in Hex
         this.HexNetAdress = HexNetAdress;       // Hexadezimal Netzadresse
         this.HexWildcard = HexWildcard;	 // Hexadezimale Wildcardmask
         this.DezNetAdress = new Array(4);       // Dezimal Netzadresse
         this.DezNetmLength = DezNetmLength;     // Dezimal Laenge der Netzmaske
         this.HexInvNetmask = HexInvNetmask;     // Invertierte Netzmaske in Hexadezimal
         this.StrWildcardmask = StrWildcardmask; // Invertierte Netzmaske in Notation a.b.c.d
         this.StrNetAdress = StrNetAdress;       // Netzadresse als String in der Notation a.b.c.d
         this.HexFirstHost = HexFirstHost;       // Hexadezimal erste Hostadresse
         this.HexLastHost = HexLastHost;         // Hexadezimal letzte Hostadresse
         this.HexBroadcast = HexBroadcast;       // Hexadezimal BroadcastAdresse
         this.DezNbrHosts = DezNbrHosts;         // Anzahl der Host im Subnetz, in Dezimal
         this.comment = comment;                 // Feld fuer Kommentare zur Loesung
         this.Notation = Notation;               // Flag, hier wird festglegt in welcher Notation die 
                                                 // Ergebnisse Dargestellt werden sollen
         this.hexToDez2 = hexToDez2;             // Methode um aus Hex Werten ein Array von vier
                                                 // Dezimalzalen zu machen
         this.dezToString2 = dezToString2;       // Methode um aus einem Array von Dezimal Zahlen  
                                                 // einen String in der Notation a.b.c.d
	 
         this.calculate2 = calculate2;           // Erzeugt die Ergbnisse innerhalb der Struktur
         this.analyse = analyse;                 // Methode analysiert das Ergebniss und schreibt 
                                                 // ggf. ein Kommentar in das Feld commment.
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// caculatePressed:   Aufruf aus der HTML Datei den gedrueckten Kalkulations-Button.
//                    Zeigt kurz den gerueckten Kalulations-Button anund gibt den Aufruf die caculations rotine weiter
//                    
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner

function caculatePressed(unpressedbutton, pressedButton,feldName){
 // kurz gedrueckten Button anzeigen
 displayButton(unpressedbutton, pressedButton,feldName);

 // Kalulation durchfuerhren
 calculate();


}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// displayButton:     Aufruf den einzelnen Start-Rotinen der gedrueckten Buttons.
//                    Zeigt kurz den gerueckten Button an und gibt den Aufruf an die eignetliche Bearbeitungsroutine 
//                    ab.
//                    
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner
function displayButton(unpressedbutton, pressedButton,feldName) {



  // Globale Variable setzen 
  // Dies ist notwendig da die Methode setTimeout() parallel zum laufenden Funktion gestartet wird.
  // nach Ablauf des Timeouts stehen daher die lokalen Variablen nicht mehr zur Verfuegung.

 feld_name        = feldName;
 unpressed_button = unpressedbutton;
 
 
 // gedrueckten Button anzeigen
 document.getElementsByName(feldName)[0].src = pressedButton;

 // nach 150ms wieder ungedrueckten Button anzeigen
  window.setTimeout('document.getElementsByName(feld_name)[0].src = unpressed_button',150);
 
 
 
} 


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// HtmlData:          Unterfunktion von GenerateNetworks() Ermittelt anhand der Auswahlfelder OUPTPUT1-5 welcher 
//                    Output fuer die automatische Generierung von Netzen gewuenscht ist, ermittelt die gewuenschten 
//                    Werte und gibt diese zurueck.
// Uebergabewert:     Result-Struktur mit den aktuellen Werten der zu ermittelnden Netze
// Rueckgabe:         HTML formtierter Ausgabe String, ohne Head und Boddy Elemente

function HtmlData(results) {
var temp = "<tr>";                                          // Zwischenspeicher fuer Ausgabestring
var auswahl = new Array();                                  // Hier werden die Indexe der ausgewaehlten Optionen gespeichert
var i = 0;

// Die Auswahlfelder durchscannen und die Ausgewaehlten Optionen ermitteln, da das Element[0] immer NULL ist
// fangen wir beim Element 1 an.
 for (i=1; i<document.forms.GENERATE.elements.length; i++) {
      
      auswahl[i] = document.forms.GENERATE.elements[i].selectedIndex;                                         
 }

 // Daten ermitteln und ausgeben
 i =1;
 for(i in auswahl) {
       switch(auswahl[i]) {
       case 0: break;
       case 1: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexIpAdress)); break;
       case 2: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexNetAdress)); break;
       case 3: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexFirstHost)); break;
       case 4: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexLastHost)); break;
       case 5: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexNetMask)); break;
       case 6: temp = temp + "<td align=\"center\">" + results.dezToString2(results.hexToDez2(results.HexWildcard)); break;
       case 7: temp = temp + "<td align=\"center\">" + results.DezNetmLength; break;
       default: temp = temp + "<td>"; break;
       }
  temp = temp + "</td>";
 }


temp = temp + "</tr>\n";
return temp;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// HtmlHeadline:      Unterfunktion von GenerateNetworks() Ermittelt anhand der Auswahlfelder OUPTPUT1-5 welcher 
//                    Output f�r die automatische Generierung von Netzen gewuenscht ist und uebergibt die UEberschriften
//                    zurueck.
// Uebergabewert:     Result-Struktur mit den aktuellen Werten der zu ermittelnden Netze
// Rueckgabe:         HTML formtierter Ausgabe String, ohne Head und Boddy Elemente
function HtmlHeadline(results) {
var temp = "<tr>";                                              // Zwischenspeicher f�r Ausgabestring
var i = 1;
var k = 0;



// Die Auswahlfelder durchscannen und die Ausgewaehlten Optionen ermitteln, da das Eelemet [0] immer NULL ist
// fangen wir beim Element 1 an.
 for (i=1; i<document.forms.GENERATE.elements.length; i++) {
      
      k = document.forms.GENERATE.elements[i].selectedIndex;                                         
      if(k > 0) {
          temp = temp + "<td align=\"center\">" + document.forms.GENERATE.elements[i].options[k].value + "</td>";

         }

 }

temp = temp + "</tr>\n";
return temp;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// GenerateNetworks:  Erzeugt an Hand der Eingabe n Netze und gibt diese in einem neuen �bergabefenster aus.
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner
function GenerateNetworks(unpressedbutton, pressedButton,feldName) {

 var IPAddress = new word();
 var Netmask = new word();
 var Wildcardmask = new word();
 var results = new result();
 var AddIpHex = 0x00000001;                         
 var NbrNetworks = 0;
 var NewWindow;
 var HtmlOut = "<html><head><title>Liste</title></head><body><table border=\"1\"><tbody>\n";
 var i = 0;

 // kurz gedrueckten Button anzeigen lassen
 displayButton(unpressedbutton, pressedButton,feldName);
 
 // Erst mal normal kalkulieren und Plausibilitaet der Eingaben pruefen
 if (calculate() != "OK") { return; }

 // Ausgabenotation festlegen
 results.Notation = document.getElementsByName("NOTATION")[0].checked;
 
 // Variablen initialsieren
 IPAddress.Str = "";
 IPAddress.Dez = document.INPUT.IPADRR.value.split(".");
 results.HexIpAdress = IPAddress.dezToHex();
 Netmask.Dez = document.INPUT.NETMASK.value.split(".");
 Netmask.NMlength = document.INPUT.NMLENGTH.value;
 Netmask.dezToHex();

 // Wildcarmask ermitteln
 Wildcardmask.Str = document.INPUT.NETMASK.value;
 Wildcardmask.Dez = document.INPUT.NETMASK.value.split(".");
 Wildcardmask.dezToHex();
 Wildcardmask.Hex = Wildcardmask.Hex ^ 0xFFFFFFFF;
 NbrNetworks = document.GENERATE.NBRNETWORKS.value;
 
 // Eingabe fuer die Anzahl der gewuenschten Netze ueberpruefen
 if (NbrNetworks > 999 || NbrNetworks < 1 || NbrNetworks.match(/\d/) == null) {
      document.getElementById("ERROR2").firstChild.nodeValue = "Die Anzahl der erzeugten Netze muss zwischen 1 und 999 liegen";
      return;
    }

 // Ausgangsdaten in die Loesungstruktur einlesen
 results.HexIpAdress = IPAddress.Hex;
 results.HexNetMask = Netmask.Hex;
 results.DezNetmLength = Netmask.NMlength;
 results.HexWildcard = Wildcardmask.Hex;

 // Additionsfaktor fuer das naechsten Netz eritteln
 AddIpHex = AddIpHex << (32 - Netmask.NMlength);

 // Netze berechnen und in die Variable HtmlOut schreiben
 HtmlOut = HtmlOut + HtmlHeadline(results);                //Headline generieren und ausgeben
 for (i=1; i<=NbrNetworks; i++) {

   // Ergebnis ermitteln
   results.calculate2();
   
   HtmlOut = HtmlOut + HtmlData(results);        // Einzelergebnisse ausgeben

   // Naechstes  Netz ermitteln
   results.HexIpAdress = results.HexIpAdress + AddIpHex;
   
      
 }
 // Ausgabevariable abschliesen und ausgeben
 HtmlOut = HtmlOut + "</tbody></table></body></html>";
 NewWindow = window.open();
 NewWindow.document.write(HtmlOut);
 NewWindow.document.close();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Initialisiern:  Setzt beim Start des Programm die Ausgangswerte in der Eingabemaske
// Uebergabewert:  keiner
// Rueckgabe:      keiner
function init() {
  document.INPUT.IPADRR.value = "192.168.1.1";
  document.INPUT.NETMASK.value = "255.255.255.0";
  document.INPUT.NMLENGTH.value ="24";
}




// Kalkulieren:  Hier werden zunaechts die Eingabewerte geprueft und dann die Kalkulationen 
// durchgefuehrt und die Ergebnisse ausgegeben.
// Uebergabewert: keinerdezToString2
// Rueckgabe: OK oder ERROR
function calculate(){
 var IPAddress = new word();
 var Netmask = new word();
 var Wildcardmask = new word();
 var results = new result();
 

 // DEBUG
 
 // Ausgabenotation festlegen
 results.Notation = document.getElementsByName("NOTATION")[0].checked;
 
 // Hinweisfeld loeschen
 document.getElementById("ERROR").firstChild.nodeValue = " ";
 document.getElementById("ERROR2").firstChild.nodeValue = " ";
 

 // Pruefen ob die eingegeben Werte (IP-Adresse, Netzmaske und Laenge der Netzmaske ) der Notation entsprechen
 if (plausiIP() == -1) { return("ERROR"); }
 if (plausiNM() == -1) { return("ERROR"); }
 if (plausiNetmasklength()== -1) { return("ERROR"); }

 // Die IP-Adresse und die Netzmaske in die Objekstruktur einlesen

 IPAddress.Str = document.INPUT.IPADRR.value;
 IPAddress.Dez = document.INPUT.IPADRR.value.split(".");
 IPAddress.dezToHex(); 
 
 Netmask.Str = document.INPUT.NETMASK.value;
 Netmask.Dez = document.INPUT.NETMASK.value.split(".");
 Netmask.dezToHex();
 Netmask.NMlength = document.INPUT.NMLENGTH.value;

 // Wildcarmask ermitteln
 Wildcardmask.Str = document.INPUT.NETMASK.value;
 Wildcardmask.Dez = document.INPUT.NETMASK.value.split(".");
 Wildcardmask.dezToHex();
 Wildcardmask.Hex = Wildcardmask.Hex ^ 0xFFFFFFFF;


 // Ausgangsdaten in die Loesungstruktur einlesen
 results.HexIpAdress = IPAddress.Hex;
 results.HexNetMask = Netmask.Hex;
 results.DezNetmLength = Netmask.NMlength;
 results.HexWildcard = Wildcardmask.Hex;

 // Ergebnis ermitteln
 results.calculate2();


 // Ergebnisse ausgeben
 // 1. Die Netzadresse
 document.getElementById("NETADRR").firstChild.nodeValue = results.dezToString2(results.hexToDez2(results.HexNetAdress));

 // 2. Netzmaske Wildcardmask und Netzmaskenlaenge.
 document.getElementById("NETMASKOUT").firstChild.nodeValue = results.dezToString2(results.hexToDez2(results.HexNetMask));

 document.getElementById("WILDCARDMASK").firstChild.nodeValue = results.dezToString2(results.hexToDez2(results.HexWildcard));



// document.getElementById("WILDCARDMASK").firstChild.nodeValue = 
results.StrWildcardmask;
 document.getElementById("ADDRLENGTH").firstChild.nodeValue = results.DezNetmLength;

 // 3. Erste Hostadresse, hier wird geprueft ob eine 255.255.255.254 Netzmaske verwendet wir,
 //  diese macht keinen Sinn da es in einem solchen Netz keine Host's gibt (Nur Netzadresse und
 // Broadcast).
 if ( Netmask.Dez[3] == 254 ) {
     document.getElementById("FIRSTHOST").firstChild.nodeValue = "-";
    }
 else {
      document.getElementById("FIRSTHOST").firstChild.nodeValue = results.dezToString2(results.hexToDez2(results.HexFirstHost));
    }
 
 // 4. Anzahl der Host's ermitteln.
 // dabei ist zu beachten das bei der Netzmaske 255.255.255.255 ein Host zulaessig ist
 // (= reine Hostadresse).
 if ( Netmask.Dez[3] == 255 ) {
    document.getElementById("NBRHOST").firstChild.nodeValue = "1";
 }
 else {
    document.getElementById("NBRHOST").firstChild.nodeValue = results.DezNbrHosts;
 }

 // 5. Letzte Hostadresse ermitteln, hier ist zu beachten das geprueft werden muss ob die
 // Netzmnaske nach einer Hostadresse fragt, dann gibt es nur eine 1. Hostadresse.
 if ( Netmask.Dez[3] == 255 || Netmask.Dez[3] == 254 ) {
     document.getElementById("LASTHOST").firstChild.nodeValue = "-";
    }
 else {
       document.getElementById("LASTHOST").firstChild.nodeValue = results.dezToString2(hexToDez2(results.HexLastHost));
      }
 // 6. Broadcastadresse ermitteln, hier ist zu beachten das geprueft werden muss ob die
 // Netzmnaske nach einer Hostadresse fragt, dann gibt es nur eine 1. Hostadresse.
 if ( Netmask.Dez[3] == 255 || Netmask.Dez[3] == 254 ) {
     document.getElementById("BRODCAST").firstChild.nodeValue = "-";
    }
 else {
       document.getElementById("BRODCAST").firstChild.nodeValue = results.dezToString2(hexToDez2(results.HexBroadcast));
      }
 // 7. Ergebnis Analysieren und ggf. Kommentar ausgeben.
  results.analyse();
  document.getElementById("REMARKS").firstChild.nodeValue = results.comment;

 return("OK");
}


// Plausibilitaestpruefung: Das Eingabefeld IP-Adresse werden auf gueltige Werte geprueft.
// Bei fehlerhafter Eingabe wird ein Hinweistext im Feld "Error" ausgegeben.
// Uebergabewert: keiner
// Rueckgabe: -1 wenn Plauspruefung fehlergefunden hat, 0 wenn OK
function plausiIP() {

var text = plausi1(document.INPUT.IPADRR.value);
if (text != "OK")
   {
    document.getElementById("ERROR").firstChild.nodeValue = "IP Adresse ist "+text;
    focus(document.INPUT.IPADRR);
    return(-1);
   }

text = plausi2(str_error=document.INPUT.IPADRR.value);
if (text != "OK")
   {
    document.getElementById("ERROR").firstChild.nodeValue = text;
    return(-1);
   }
 return(0);
}

// Plausibilitaestpruefung: Plausibilitaetsprüfung fuer das Feld Netmasklength.
// Bei fehlerhafter Eingabe wird ein Hinweistext im Feld "Error" ausgegeben.
// Uebergabewert: keiner
// Rueckgabe: -1 wenn Plauspruefung fehlergefunden hat, 0 wenn OK
function plausiNetmasklength() {
var netmasklength = document.INPUT.NMLENGTH.value;

if (netmasklength > 32 || netmasklength < 1)
   {
    document.getElementById("ERROR").firstChild.nodeValue = "Die Laenge der Netzmaske muss zwischen 1 und 32 liegen.";
    focus(document.INPUT.NMLENGTH);
    return(-1);
   }

   
 return(0);
}




// Plausibilitaestpruefung: Das Eingabefeld Netzmaske werden auf guelte Werte geprueft.
// Bei fehlerhafter Eingabe wird ein Hinweistext im Feld "Error" ausgegeben.
// Uebergabewert: keiner
// Rueckgabe: -1 wenn Plauspruefung fehlergefunden hat, 0 wenn OK
function plausiNM() {
var temp = new word();

temp.Str = document.INPUT.NETMASK.value;
document.getElementById("ERROR").firstChild.nodeValue = " ";

// Pruefen ob Netzmaske nicht leer ist
var text = plausi1(temp.Str);
if (text != "OK")
   {
    document.getElementById("ERROR").firstChild.nodeValue = "Netzmaske ist "+text;
    focus(document.INPUT.NETMASK);
    return(-1);
   }

// Pruefen ob Netzmaske aus 4 Dezimalzahlen besteht die durch Punkte (Dots) getrennt sind
text = plausi2(temp.Str);
if (text != "OK")
   {
    document.getElementById("ERROR").firstChild.nodeValue = text;
    return(-1);
   }

// Pruefen das die zulaessigen Werte in die Netzmaske eingegeben wurden
text = ckValueNM(temp.Str);
if (text != "OK")
   {
    document.getElementById("ERROR").firstChild.nodeValue = text;
    return(-1);
   }
 temp.StringToNMlength();
 document.INPUT.NMLENGTH.value = temp.NMlength;
 return(0);
}


// Plausibilitaestpruefung 1: Sowohl IP-Adresse als auch Netzmaske d�rfen nicht leer sein. 
// Uebergabewert: Zu pr�fender String
// Rueckgabe: OK wenn Plausipruefung in Ordnung war, sonst Hinweistext.
function plausi1(Eingabe) {
if (Eingabe == "") {
   return "ein Pflichtfeld, bitte ausfuellen.";
}
return "OK";
}

// Plausibilitaestpruefung 2: Sowohl IP-Adresse als auch Netzmaske muss aus 4 Dezimalzahlen die 
// durch 3 Punkte (Dots) getrennt sind bestehen.
// Uebergabewert: Zu pr�fender String
// Rueckgabe: OK wenn Plausipruefung in Ordnung war, sonst Hinweistext.
function plausi2(Eingabe) {
  if (Eingabe.match(/\d+\.+\d+\.+\d+\.+\d/) == null) {
   return "Die Werte muessen aus 4 ganzen Zahlen die durch Punkte getrennt sind bestehen (z. B. 172.16.1.84 fuer IP-Adresse oder 255.255.255.0 fuer Netzmaske).";}
return "OK";
}

// Plausibilitaestpruefung Maskenlaenge: Die Laenge der Netzmaske muss zwischen 1 und 32 liegen, 
// dies wird hier �berprueft.
// Bei fehlerhafter Eingabe wird ein Hinweistext im Feld "Error" ausgegeben.
// Uebergabewert: keinen
// Rueckgabe: OK wenn Plausipruefung in Ordnung war, sonst Hinweistext.
function netmaskLength() {
var temp = new word();

temp.NMlength = document.INPUT.NMLENGTH.value;


document.getElementById("ERROR").firstChild.nodeValue = " ";


 if (temp.NMlength >= 33 || temp.NMlength < 1) {
     document.getElementById("ERROR").firstChild.nodeValue = "Die Laenge der Netzmaske muss zwischen 1 und 32 liegen.";
     focus(document.INPUT.NMLENGTH);
     return;
    }
temp.NMlengthToString();
document.INPUT.NETMASK.value = temp.Str;
calculate();

}
// Plausibilitaestpruefung der Netmaskwerte: F�r die Netzmaske sind nur bestimmte Werte zulaessig.
// Dies wird hier �berprueft.
// Bei fehlerhafter Eingabe wird ein Hinweistext im Feld "Error" ausgegeben.
// Uebergabewert: Zu pruefender String
// Rueckgabe: OK wenn Plausipruefung in Ordnung war, sonst Hinweistext.
function ckValueNM(Eingabe) {
 var temp = new word();
 var formatfalsch = "Das Format fuer die Netzmaske ist falsch. Tip: Versuchen Sie es ueber das Eingabefeld Laenge der Netzmaske."
 var i = 0;

 document.getElementById("ERROR").firstChild.nodeValue = " ";
 temp.Dez = Eingabe.split(".");
 
 for ( i=0; i<=3; i++) {
       switch(parseInt(temp.Dez[i])) {
       case 255: break;
       case 254: break;
       case 252: break;
       case 248: break;
       case 240: break;
       case 224: break;
       case 192: break;
       case 128: break;
       case 0: break;
       default: return("Bei der Netzmaske sind nur die Werte 255, 254, 252, 240, 192 oder 128 zulaessig.");
       }
     }
// Nun testen wir ob das Format stimmt, bei der Netzmaske handelt es sich Binaer gesehen um ein 
// 32-Bit Feld was von Links(MSB) mit 1 aufgefuellt sein muss 

 if (temp.Dez[0] != 255) {
     if (temp.Dez[1] == 0 && temp.Dez[2] == 0 && temp.Dez[3] == 0) {return("OK");}
     else { return(formatfalsch); }
    }
 if (temp.Dez[1] != 255) {
     if (temp.Dez[2] == 0 && temp.Dez[3] == 0) {return("OK");}
     else { return(formatfalsch); }
    }
 if (temp.Dez[2] != 255) {
     if (temp.Dez[3] == 0) {return("OK");}
     else { return(formatfalsch); }
    }



 return("OK");
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Erhoeht die Laenge der Netzmaske um 1 bis Max. 32 und passt das Feld Netmask in der Eingemaske 
// entsprechend an.
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner
function NMup(unpressedbutton, pressedButton,feldName) {
 var temp = new word();

 // kurz gedrueckten Button anzeigen lassen
 displayButton(unpressedbutton, pressedButton,feldName);

 temp.NMlength = document.INPUT.NMLENGTH.value;

 if (temp.NMlength <=31) { temp.NMlength ++; }

 document.INPUT.NMLENGTH.value = temp.NMlength;
 temp.NMlengthToString();
 document.INPUT.NETMASK.value = temp.Str;
 calculate();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Vermindert die Laenge der Netzmaske um 1 bis Min. 0 und passt das Feld Netmask in der
// Eingemaske entsprechend an.
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe: 	      keiner
function NMdown(unpressedbutton, pressedButton,feldName) {
 var temp = new word();

 // kurz gedrueckten Button anzeigen lassen
 displayButton(unpressedbutton, pressedButton,feldName);


 temp.NMlength = document.INPUT.NMLENGTH.value;

 if (temp.NMlength >1 ) { temp.NMlength --; }

 document.INPUT.NMLENGTH.value = temp.NMlength;
 temp.NMlengthToString();
 document.INPUT.NETMASK.value = temp.Str;
 calculate();
}

// Konvertierung der einzelnen dezimalen Werte fuer Netzmaske oder IP-Adresse in 32-Bit Hex-Wert
// Uebergabewert: keiner
// Rueckgabewert: keiner
function dezToHex() {
 this.Hex = 0x00000000;
 this.Hex = this.Hex | this.Dez[0] <<24;
 this.Hex = this.Hex | this.Dez[1] <<16;
 this.Hex = this.Hex | this.Dez[2] <<8;
 this.Hex = this.Hex | this.Dez[3];
}

// Methode zur Konvertierung der Netzmaskenlaenge in den Netzmasken String
// Uebergabewert: keiner
// Rueckgabe: keiner
function NMlengthToString() {

switch(parseInt(this.NMlength)) {
    case 0: this.Str = "0.0.0.0"; break;
    case 1: this.Str = "128.0.0.0"; break;
    case 2: this.Str = "192.0.0.0"; break;
    case 3: this.Str = "224.0.0.0"; break;
    case 4: this.Str = "240.0.0.0"; break;
    case 5: this.Str = "248.0.0.0"; break;
    case 6: this.Str = "252.0.0.0"; break;
    case 7: this.Str = "254.0.0.0"; break;
    case 8: this.Str = "255.0.0.0"; break;
    case 9: this.Str = "255.128.0.0"; break;
    case 10: this.Str = "255.192.0.0"; break;
    case 11: this.Str = "255.224.0.0"; break;
    case 12: this.Str = "255.240.0.0"; break;
    case 13: this.Str = "255.248.0.0"; break;
    case 14: this.Str = "255.252.0.0"; break;
    case 15: this.Str = "255.254.0.0"; break;
    case 16: this.Str = "255.255.0.0"; break;
    case 17: this.Str = "255.255.128.0"; break;
    case 18: this.Str = "255.255.192.0"; break;
    case 19: this.Str = "255.255.224.0"; break;
    case 20: this.Str = "255.255.240.0"; break;
    case 21: this.Str = "255.255.248.0"; break;
    case 22: this.Str = "255.255.252.0"; break;
    case 23: this.Str = "255.255.254.0"; break;
    case 24: this.Str = "255.255.255.0"; break;
    case 25: this.Str = "255.255.255.128"; break;
    case 26: this.Str = "255.255.255.192"; break;
    case 27: this.Str = "255.255.255.224"; break;
    case 28: this.Str = "255.255.255.240"; break;
    case 29: this.Str = "255.255.255.248"; break;
    case 30: this.Str = "255.255.255.252"; break;
    case 31: this.Str = "255.255.255.254"; break;
    case 32: this.Str = "255.255.255.255"; break;

    default: break;
   }
}


// Methode zur Konvertierung des Netzmasken String in die Netzmaskenlaenge 
// Uebergabewert: keiner
// Rueckgabe: keiner
function StringToNMlength() {

 switch(this.Str) {
    case "0.0.0.0": this.Dez = 0; break;
    case "128.0.0.0": this.NMlength = 1; break;
    case "192.0.0.0": this.NMlength = 2; break;
    case "224.0.0.0": this.NMlength = 3; break;
    case "240.0.0.0": this.NMlength = 4; break;
    case "248.0.0.0": this.NMlength = 5; break;
    case "252.0.0.0": this.NMlength = 6; break;
    case "254.0.0.0": this.NMlength = 7; break;
    case "255.0.0.0": this.NMlength = 8; break;
    case "255.128.0.0": this.NMlength = 9; break;
    case "255.192.0.0": this.NMlength = 10; break;
    case "255.224.0.0": this.NMlength = 11; break;
    case "255.240.0.0": this.NMlength = 12; break;
    case "255.248.0.0": this.NMlength = 13; break;
    case "255.252.0.0": this.NMlength = 14; break;
    case "255.254.0.0": this.NMlength = 15; break;
    case "255.255.0.0": this.NMlength = 16; break;
    case "255.255.128.0": this.NMlength = 17; break;
    case "255.255.192.0": this.NMlength = 18; break;
    case "255.255.224.0": this.NMlength = 19; break;
    case "255.255.240.0": this.NMlength = 20; break;
    case "255.255.248.0": this.NMlength = 21; break;
    case "255.255.252.0": this.NMlength = 22; break;
    case "255.255.254.0": this.NMlength = 23; break;
    case "255.255.255.0": this.NMlength = 24; break;
    case "255.255.255.128": this.NMlength = 25; break;
    case "255.255.255.192": this.NMlength = 26; break;
    case "255.255.255.224": this.NMlength = 27; break;
    case "255.255.255.240": this.NMlength = 28; break;
    case "255.255.255.248": this.NMlength = 29; break;
    case "255.255.255.252": this.NMlength = 30; break;
    case "255.255.255.254": this.NMlength = 31; break;
    case "255.255.255.255": this.NMlength = 32; break;
    default: break;
   }
}
// Konvertierung des 32-Bit Hex-Wertes in 4 einzelnen dezimal Werte f�r die result-Struktur
// Uebergabewert: Hex-Wert
// Rueckgabe: Array aus 4 Dezimal Zahlem MSB ist Array[0]
function hexToDez2(Eingabe) {
 var Dez = new Array(4);
 var temp;


 temp = Eingabe & 0xFF000000;
 temp = temp >> 24;
 Dez[0] = parseInt(temp);
 // Ist das oberste Bit gesetz so bedeute die das es sich um eine negative Zahl handelt, (was in
 //  diesem Zusammenhang natuerlich nicht stimmt.) daher muss in diesm Fall einwenig getrixt
 // werden und eine ganze Zahl daraus macht werden. 
 if (Dez[0]<0) { Dez[0] = 256 + Dez[0] }
   
 temp = Eingabe & 0x00FF0000;
 temp = temp >> 16;
 Dez[1] = parseInt(temp);

 temp = Eingabe & 0x0000FF00;
 temp = temp >> 8;
 Dez[2] = parseInt(temp);

 temp = Eingabe & 0x000000FF;
 Dez[3] = parseInt(temp);
 
 return Dez;
}
// Konvertierung die in einem Array abgelegten 4 einzelnen dezimal Werte in einen String
// welcher durch Punkte (Dots getrennt ist. Notation a.b.c.d.
// Wenn Flag auf True steht werden fuehrende Nullen fuer die Darstellung von IP-Adressen und
// Netzmaske verwendet: 10.1.12.1 wird 010.001.012.001
// Uebergabewert: Array[4] mit Dezimalwerten, MSB = Arry[0], Flag zur Ausgabenotation
// Rueckgabe: String
function dezToString2(Eingabe) {
var Str = "";
var i=0;

// Fuerende Nullen verwenden ?
if (this.Notation == true) {
     for( i=0; i<=3; i++ ) {

           if (Eingabe[i] == 0) {
              Str = Str + "000"; 
             }
           if (Eingabe[i] < 10 && Eingabe[i] > 0) {
              Str = Str + "00" + Eingabe[i]; 
             }
           if (Eingabe[i] > 99) {
              Str = Str  + Eingabe[i]; 
             }           
           if (Eingabe[i] < 100 && Eingabe[i] >= 10) {
              Str = Str + "0" + Eingabe[i];  
             }
           // Kein Punkt nach dem letzten Wert einfuegen
           if(i != 3) {Str = Str + ".";}
        }
     return Str;
    }

// Keine fuerhrenden Nullen verwenden
Str = Eingabe[0] + "." + Eingabe[1] + "." + Eingabe[2] + "." + Eingabe[3];
return Str;
}

// Calculate 2: Methode dient dazu die Ergebnisse in die Loesungsstruktur result zu erzeugen.
// Die Basisdaten (IP-Adresse + Netzmaske und Netzmaskenlaenge) m�ssen zuvor in die Struktur
// results eingelesen werden.
// Uebergabewert: keine
// Rueckgabe: keine
function calculate2() {
 // Netzadresse ermitteln
 this.HexNetAdress = this.HexIpAdress & this.HexNetMask;

 // Erste Hostadresse ermitteln
 this.HexFirstHost = this.HexNetAdress + 1;

 // Anzahl der Hosts ermitteln
 this.HexInvNetmask = 0xFFFFFFFF ^ this.HexNetMask; 
 this.DezNbrHosts = this.HexInvNetmask -1;

 // Letzten Host ermitteln
 this.HexLastHost = this.HexNetAdress | this.HexInvNetmask -1;

 // Broadcast Adresse ermitteln
 this.HexBroadcast = this.HexNetAdress | this.HexInvNetmask;

}
// analyse: Methode dient dazu die Ergebnisse das Ergebniss der Kalkulation zu analysieren und 
// im Feld comment der Loesungstruktur Hinweise abzulegen.
// Uebergabewert: keine
// Rueckgabe: keine
function analyse() {
this.comment = "";
var temp;


// 1. Analyse: Handelt es sich um eine Host Adresse?
if (this.DezNetmLength == 32) { this.comment = "Host IP-Adresse.\n"; } 

//2. Analyse: Handelt es sich um ein 255.255.255.254er Netzmaske?
if (this.DezNetmLength == 31) {
    this.comment = "Hinweis: Ein solches Netz macht keinen Sinn. Es hat nur eine Netz- und Broadcast Adresse, aber keine Host Adresse(n).";
   }

// 3. Analyse: Handelt es sich um eine Adresse aus dem bereich der privaten IP-Adressen nach
// RFC 1918?
// 3.1 Ist es ein Adresse aus dem Bereich 10.0.0.0.0 bis 10.255.255.255 ?
temp = hexToDez2(this.HexNetAdress & 0xFF000000);
if ( temp[0] == 10 ) {
    this.comment =  this.comment + " IP-Adresse aus dem Bereich der privaten IP-Adressen, Details hierzu siehe RFC1918.";
   }
// 3.2 Ist es ein Adresse aus dem Bereich 172.16.0.0 bis 172.31.255.255 ?

temp = hexToDez2(this.HexNetAdress & 0xFFF00000);
if ( temp[0] == 172 && temp[1] == 16 ) {
    this.comment =  this.comment + " IP-Adresse aus dem Bereich der privaten IP-Adressen, Details hierzu siehe RFC1918.";
   }

// 3.3 Ist es ein Adresse aus dem Bereich 192.168.0.0 bis 192.168.255.255 ?

temp = hexToDez2(this.HexNetAdress & 0xFFFF0000);
if (temp[0] == 192 && temp[1] == 168) {
    this.comment =  this.comment + " IP-Adresse aus dem Bereich der privaten IP-Adressen, Details hierzu siehe RFC1918.";
   }

// 3.4 Ist es ein Adresse aus dem Bereich 127.0.0.0 bis 172.255.255.255 ?

temp = hexToDez2(this.HexNetAdress & 0xFF000000);
if (temp[0] == 127 ) {
    this.comment =  this.comment + " IP-Adresse aus dem Bereich der internen Loopback Adressen, Details hierzu siehe RFC1700.";
   }
temp = hexToDez2(this.HexNetAdress & 0xFF000000);
if (temp[0] >= 224 && temp[0] <=239 ) {
    this.comment =  this.comment + " IP-Adresse aus dem Bereich der Multicast Adressen, Details hierzu siehe RFC1112.";
   }

}

// Netup:             Button Netup wurde gedrueckt, das naechste Netz wird kalkuliert und ausgegeben
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner
function NetworkUp(unpressedbutton, pressedButton,feldName){
 var IPAddress = new word();
 var Netmask = new word();
 var AddIpHex = 0x00000001;                         

 // kurz gedrueckten Button anzeigen lassen
 displayButton(unpressedbutton, pressedButton,feldName);


 // Erst mal normal kalkulieren und Plausibilitaet der Eingaben pruefen
 if (calculate() != "OK") { return; }

 // Variablen initialsieren
 IPAddress.Notation = document.INPUT.NOTATION.value;
 IPAddress.Str = "";
 IPAddress.Dez = document.INPUT.IPADRR.value.split(".");
 IPAddress.dezToHex();
 Netmask.NMlength = document.INPUT.NMLENGTH.value;

 // Additionsfaktor fuer naechsten Netz eritteln
 AddIpHex = AddIpHex << (32 - Netmask.NMlength);

 // Naechstes  Netz ermitteln und in das Eingbefeld der IP-Adresse geben
 IPAddress.Hex = IPAddress.Hex + AddIpHex;
 IPAddress.Dez = IPAddress.hexToDez2(IPAddress.Hex);
 IPAddress.String =  IPAddress.dezToString2(IPAddress.Dez); 
 document.INPUT.IPADRR.value = IPAddress.String;
 
 // Und abschliesend kalulieren und das Ergebnis ausgeben.
 calculate();
}

// Netdown:           Button Netdown wurde gedrueckt, das vohaerige Netz wird kalkuliert und ausgegeben
// Uebergabewert:     unpressedbutton = Grafikdatei des nicht gedrueckten Button
//                    pressed_button  = Grafikdatei des gedrueckten Button
//		      feldName        = HTML Name des gedrueckten Buttons
// Rueckgabe:         keiner
function NetworkDown(unpressedbutton, pressedButton,feldName){
 var IPAddress = new word();
 var Netmask = new word();
 var AddIpHex = 0x00000001;                         

 // kurz gedrueckten Button anzeigen lassen
 displayButton(unpressedbutton, pressedButton,feldName);


 // Erst mal normal kalkulieren und Plausibilitaet der Eingaben pruefen
 if (calculate() != "OK") { return; }

 // Variablen initialsieren
 IPAddress.Notation = document.INPUT.NOTATION.value;
 IPAddress.Str = "";
 IPAddress.Dez = document.INPUT.IPADRR.value.split(".");
 IPAddress.dezToHex();
 Netmask.NMlength = document.INPUT.NMLENGTH.value;

 // Additionsfaktor fuer naechsten Netz eritteln
 AddIpHex = AddIpHex << (32 - Netmask.NMlength);

 // Voheriges Netz ermitteln und in das Eingbefeld der IP-Adresse geben
 IPAddress.Hex = IPAddress.Hex - AddIpHex;
 IPAddress.Dez = IPAddress.hexToDez2(IPAddress.Hex);
 IPAddress.String =  IPAddress.dezToString2(IPAddress.Dez); 
 document.INPUT.IPADRR.value = IPAddress.String;
 
 // Und abschliesend kalulieren und das Ergebnis ausgeben.
 calculate();
}
